export declare const MOUNT_EVENT: string
export declare const UNMOUNT_EVENT: string
export declare enum DataType {
    EVENT = 'event',
    PROPS = 'props',
    CALLBACK = 'callback'
}
export declare type Data<P> = PropsData<P> | CallbackData | EventData
export interface PropsData<P> {
    type: DataType
    payload: Partial<P>
}
export interface CallbackData {
    type: DataType
    payload: {
        name: string
        args: any[]
    }
}
export interface EventData {
    type: DataType
    payload: {
        name: string
        value?: any
    }
}
export declare const isEvent: <P>(
    eventName: any
) => (data: Data<P>, index?: any) => boolean
export declare const isProps: <P>(data: Data<P>) => boolean
export declare const isCallback: <P>(
    propName: any
) => (data: Data<P>) => boolean
export declare const createEventData: (name: string, value?: any) => EventData
export declare const createPropsData: <P>(props: P) => PropsData<P>
export declare const createCallbackData: (
    name: string,
    args: any[]
) => CallbackData
export declare const shallowEquals: (left: any, right: any) => boolean
