import { Callbag, Source, Sink } from 'callbag'
import { PushEvent } from './baseTypes'
export interface Listener<T> {
    next: (val: T) => void
    error: (err: any) => void
    complete: (val?: T) => void
}
export interface Subscription {
    unsubscribe(): void
}
export interface UseEvent {
    (eventName: string): [Source<void>, () => any]
    <T = any>(eventName: string, seedValue?: T): [Source<T>, (val: T) => any]
}
export interface FromEvent {
    (eventName: string): Source<void>
    <T>(eventName: string, valueTransformer?: (val: any) => T): Source<T>
}
export interface ObservableComponentBase {
    mount: Source<any>
    unmount: Source<any>
    fromEvent: FromEvent
    pushEvent: PushEvent
    useEvent: UseEvent
}
export interface Observe {
    observe: <T>(
        propName?: string,
        valueTransformer?: (val: any) => T
    ) => Source<T>
}
export declare type ObservableComponent = Observe & ObservableComponentBase
export declare type Aperture<P, E, C = any> = (
    component: ObservableComponent,
    initialProps: P,
    initialContext?: C
) => Sink<E>
export declare const subscribeToSink: <T>(
    sink: Callbag<T, void>,
    next: (val: T) => void,
    error?: (error: any) => void
) => Subscription
export declare const getObserve: <P>(
    getProp: any,
    data: any,
    decoratedProps: any
) => <T>(propName?: any, valueTransformer?: any) => any
export declare const createComponent: <P>(
    getProp: any,
    dataObservable: any,
    pushEvent: PushEvent,
    decoratedProps: boolean
) => ObservableComponent
export declare const createObservable: (
    subscribe: any
) => {
    [x: string]: any
    subscribe: any
}
